
#ifndef __DXA_PLAYER_H__
#define __DXA_PLAYER_H__

#include "intern.h"
#include "file.h"

enum ScaleMode { S_NONE, S_INTERLACED, S_DOUBLE };

struct DXA_Player {
	static const uint32 _tagDEXA;
	static const uint32 _tagFRAM;
	static const uint32 _tagWAVE;
	static const uint32 _tagCMAP;
	
	bool _playing;
	File _fd;
	uint8 *_frameBuffer1;
	uint8 *_frameBuffer2;
	uint8 *_scaledBuffer;
	uint16 _width;
	uint16 _height, _workheight;
	uint32 _frameSize;
	uint16 _framesCount;
	uint16 _currentFrame;
	uint32 _frameTicks;
	ScaleMode _scaleMode;
	
	bool open(const char *filename);
	void close();
	void play();
	void handleNextFrame();
	void decodeZlib(uint8 *data, int size, int totalSize);
	void decode0(uint8 *data, int size);
	void decode2(uint8 *data, int size, int totalSize);
	void decode13(uint8 *data, int size, int totalSize);

};

#endif // __DXA_PLAYER_H__
